Main Page | Modules | Class Hierarchy | Alphabetical List | Class List | File List | Class Members | Related Pages

# SoSwitch Class Reference
[Nodes]

`#include <Inventor/nodes/SoSwitch.h>`

Inheritance diagram for SoSwitch:

List of all members.

## Detailed Description

The SoSwitch class is a group node which selects one child subgraph for traversal.

Which child to traverse is controlled by the application programmer by using the SoSwitch::whichChild field. In addition to picking out a single child for traversal, it is also possible to flip all children on or off for traversal.

This node is very useful for conditionally turning on or off parts of the scenegraph based on the current application processing mode, visualizing mode, or whatever else the application can do.

## Public Member Functions
| SoSwitch (void)
| SoSwitch (int numchildren)
virtual SbBool | affectsState (void) const
virtual void | doAction (SoAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | pick (SoPickAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | search (SoSearchAction *action)
virtual void | write (SoWriteAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | notify (SoNotList *nl)
## Static Public Member Functions
void | initClass (void)
## Public Attributes
SoSFInt32 | whichChild
## Protected Member Functions
virtual | ~SoSwitch ()
void | traverseChildren (SoAction *action)
## Friends
class | SoSwitchP

## Constructor & Destructor Documentation

SoSwitch::SoSwitch | ( | void |  | ) |

| Default constructor.

SoSwitch::SoSwitch | ( | int | numchildren | ) |

| Constructor. The argument should be the approximate number of children which is expected to be inserted below this node. The number need not be exact, as it is only used as a hint for better memory resource allocation.

SoSwitch::~SoSwitch | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoSwitch::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoGroup. Reimplemented in SoBlinker.

SbBool SoSwitch::affectsState | ( | void |  | ) | const`[virtual]`

| Returns `TRUE` if the node could have any effect on the state during traversal. If it returns `FALSE`, no data in the traversal-state will change from the pre-traversal state to the post-traversal state. The SoSeparator node will for instance return `FALSE`, as it pushes and pops the state before and after traversal of its children. All SoShape nodes will also return `FALSE`, as just pushing out geometry data to the rendering engine won't affect the actual rendering state. The default method returns `TRUE`, on a "better safe than sorry" philosophy. Reimplemented from SoNode.

void SoSwitch::doAction | ( | SoAction * | action | ) | `[virtual]`

| This function performs the typical operation of a node for any action. Reimplemented from SoGroup.

void SoSwitch::callback | ( | SoCallbackAction * | action | ) | `[virtual]`

| Action method for SoCallbackAction. Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph. Reimplemented from SoGroup.

void SoSwitch::GLRender | ( | SoGLRenderAction * | action | ) | `[virtual]`

| Action method for the SoGLRenderAction. This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method. Reimplemented from SoGroup.

void SoSwitch::pick | ( | SoPickAction * | action | ) | `[virtual]`

| Action method for SoPickAction. Does common processing for SoPickAction action instances. Reimplemented from SoGroup.

void SoSwitch::getBoundingBox | ( | SoGetBoundingBoxAction * | action | ) | `[virtual]`

| Action method for the SoGetBoundingBoxAction. Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node. Nodes influencing how geometry nodes calculates their bounding box also overrides this method to change the relevant state variables. Reimplemented from SoGroup. Reimplemented in SoBlinker.

void SoSwitch::handleEvent | ( | SoHandleEventAction * | action | ) | `[virtual]`

| Action method for SoHandleEventAction. Inspects the event data from action, and processes it if it is something which this node should react to. Nodes influencing relevant state variables for how event handling is done also overrides this method. Reimplemented from SoGroup.

void SoSwitch::getMatrix | ( | SoGetMatrixAction * | action | ) | `[virtual]`

| Action method for SoGetMatrixAction. Updates action by accumulating with the transformation matrix of this node (if any). Reimplemented from SoGroup.

void SoSwitch::search | ( | SoSearchAction * | action | ) | `[virtual]`

| Action method for SoSearchAction. Compares the search criteria from the action to see if this node is a match. Searching is done by matching up all criteria set up in the SoSearchAction -- if any of the requested criteria is a miss, the search is not deemed successful for the node. See also: SoSearchAction Reimplemented from SoGroup.

void SoSwitch::write | ( | SoWriteAction * | action | ) | `[virtual]`

| Action method for SoWriteAction. Writes out a node object, and any connected nodes, engines etc, if necessary. Reimplemented from SoGroup. Reimplemented in SoBlinker.

void SoSwitch::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) | `[virtual]`

| Action method for the SoGetPrimitiveCountAction. Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action. Nodes influencing how geometry nodes calculates their primitive count also overrides this method to change the relevant state variables. Reimplemented from SoGroup.

void SoSwitch::audioRender | ( | SoAudioRenderAction * | action | ) | `[virtual]`

| Action method for SoAudioRenderAction. Does common processing for SoAudioRenderAction action instances. Reimplemented from SoGroup.

void SoSwitch::notify | ( | SoNotList * | nl | ) | `[virtual]`

| Notifies all auditors for this instance when changes are made. Reimplemented from SoNode. Reimplemented in SoBlinker.

void SoSwitch::traverseChildren | ( | SoAction * | action | ) | `[protected]`

| This function was part of the original SGI Inventor API, but it is not supported in Coin, as it looks like it should probably have been private in Inventor.

## Member Data Documentation

SoSFInt32 SoSwitch::whichChild

| Selects which child to traverse during rendering (and some other) actions. The value should be either `SO_SWITCH_NONE` (for traversing no children, like it was an empty SoGroup node), `SO_SWITCH_ALL` (for traversing like if we were an SoGroup node), `SO_SWITCH_INHERIT` (for traversing the same child as the last SoSwitch node to parent this in the graph), or an index value for a child. When constructing ascii Inventor files, the integer values for the keywords must be used instead of their names. They are -1 for `SO_SWITCH_NONE`, -2 for `SO_SWITCH_INHERIT`, and -3 for `SO_SWITCH_ALL`. Default value for the field is `SO_SWITCH_NONE`.

The documentation for this class was generated from the following files:

- SoSwitch.h
- SoSwitch.cpp